diff --git a/src/include/access/spgist.h b/src/include/access/spgist.h
new file mode 100644
index 0cb8fd9..ba2c1c1
*** a/src/include/access/spgist.h
--- b/src/include/access/spgist.h
***************
*** 14,20 ****
  #ifndef SPGIST_H
  #define SPGIST_H
  
! #include "access/skey.h"
  #include "access/xlogreader.h"
  #include "fmgr.h"
  #include "lib/stringinfo.h"
--- 14,20 ----
  #ifndef SPGIST_H
  #define SPGIST_H
  
! #include "access/amapi.h"
  #include "access/xlogreader.h"
  #include "fmgr.h"
  #include "lib/stringinfo.h"
*************** typedef struct spgLeafConsistentOut
*** 174,200 ****
  } spgLeafConsistentOut;
  
  
  /* spginsert.c */
! extern Datum spgbuild(PG_FUNCTION_ARGS);
! extern Datum spgbuildempty(PG_FUNCTION_ARGS);
! extern Datum spginsert(PG_FUNCTION_ARGS);
  
  /* spgscan.c */
! extern Datum spgbeginscan(PG_FUNCTION_ARGS);
! extern Datum spgendscan(PG_FUNCTION_ARGS);
! extern Datum spgrescan(PG_FUNCTION_ARGS);
! extern Datum spgmarkpos(PG_FUNCTION_ARGS);
! extern Datum spgrestrpos(PG_FUNCTION_ARGS);
! extern Datum spggetbitmap(PG_FUNCTION_ARGS);
! extern Datum spggettuple(PG_FUNCTION_ARGS);
! extern Datum spgcanreturn(PG_FUNCTION_ARGS);
  
  /* spgutils.c */
! extern Datum spgoptions(PG_FUNCTION_ARGS);
  
  /* spgvacuum.c */
! extern Datum spgbulkdelete(PG_FUNCTION_ARGS);
! extern Datum spgvacuumcleanup(PG_FUNCTION_ARGS);
  
  /* spgxlog.c */
  extern void spg_redo(XLogReaderState *record);
--- 174,212 ----
  } spgLeafConsistentOut;
  
  
+ /* spgutils.c */
+ extern Datum spghandler(PG_FUNCTION_ARGS);
+ extern void spgvalidate(OpClassInfo *opclass);
+ 
  /* spginsert.c */
! extern IndexBuildResult *spgbuild(Relation heap, Relation index,
! 								  IndexInfo *indexInfo);
! extern void spgbuildempty(Relation indexRelation);
! extern bool spginsert(Relation index, Datum *values, bool *isnull,
! 					  ItemPointer ht_ctid, Relation heapRel,
! 					  IndexUniqueCheck checkUnique);
  
  /* spgscan.c */
! extern IndexScanDesc spgbeginscan(Relation rel, int keysz, int orderbysz);
! extern void spgendscan(IndexScanDesc scan);
! extern void spgrescan(IndexScanDesc scan, ScanKey key, int nkeys,
! 					  ScanKey orderbys, int norderbys);
! extern void spgmarkpos(IndexScanDesc scan);
! extern void spgrestrpos(IndexScanDesc scan);
! extern int64 spggetbitmap(IndexScanDesc scan, TIDBitmap *tbm);
! extern bool spggettuple(IndexScanDesc scan, ScanDirection dir);
! extern bool spgcanreturn(Relation index, int attno);
  
  /* spgutils.c */
! extern bytea *spgoptions(Datum reloptions, bool validate);
  
  /* spgvacuum.c */
! extern IndexBulkDeleteResult *spgbulkdelete(IndexVacuumInfo *info,
! 											IndexBulkDeleteResult *stats,
! 											IndexBulkDeleteCallback callback,
! 											void *callback_state);
! extern IndexBulkDeleteResult *spgvacuumcleanup(IndexVacuumInfo *info,
! 											   IndexBulkDeleteResult *stats);
  
  /* spgxlog.c */
  extern void spg_redo(XLogReaderState *record);
diff --git a/src/include/catalog/opfam_internal.h b/src/include/catalog/opfam_internal.h
new file mode 100644
index 32195a7..2cbefe9
*** a/src/include/catalog/opfam_internal.h
--- b/src/include/catalog/opfam_internal.h
*************** typedef struct
*** 25,28 ****
--- 25,41 ----
  	Oid			sortfamily;		/* ordering operator's sort opfamily, or 0 */
  } OpFamilyMember;
  
+ /*
+  * Opclass data for validation by access method.
+  */
+ typedef struct
+ {
+ 	Oid			amoid;			/* access method OID */
+ 	Oid			intype;			/* input datatype */
+ 	Oid			keytype;		/* key datatype */
+ 	List	   *procedures;		/* list of OpFamilyMember */
+ 	List	   *operators;		/* list of OpFamilyMember */
+ } OpClassInfo;
+ 
+ 
  #endif   /* OPFAM_INTERNAL_H */
diff --git a/src/include/catalog/pg_am.h b/src/include/catalog/pg_am.h
new file mode 100644
index 8a28b8e..f19a873
*** a/src/include/catalog/pg_am.h
--- b/src/include/catalog/pg_am.h
***************
*** 34,72 ****
  CATALOG(pg_am,2601)
  {
  	NameData	amname;			/* access method name */
! 	int16		amstrategies;	/* total number of strategies (operators) by
! 								 * which we can traverse/search this AM. Zero
! 								 * if AM does not have a fixed set of strategy
! 								 * assignments. */
! 	int16		amsupport;		/* total number of support functions that this
! 								 * AM uses */
! 	bool		amcanorder;		/* does AM support order by column value? */
! 	bool		amcanorderbyop; /* does AM support order by operator result? */
! 	bool		amcanbackward;	/* does AM support backward scan? */
! 	bool		amcanunique;	/* does AM support UNIQUE indexes? */
! 	bool		amcanmulticol;	/* does AM support multi-column indexes? */
! 	bool		amoptionalkey;	/* can query omit key for the first column? */
! 	bool		amsearcharray;	/* can AM handle ScalarArrayOpExpr quals? */
! 	bool		amsearchnulls;	/* can AM search for NULL/NOT NULL entries? */
! 	bool		amstorage;		/* can storage type differ from column type? */
! 	bool		amclusterable;	/* does AM support cluster command? */
! 	bool		ampredlocks;	/* does AM handle predicate locks? */
! 	Oid			amkeytype;		/* type of data in index, or InvalidOid */
! 	regproc		aminsert;		/* "insert this tuple" function */
! 	regproc		ambeginscan;	/* "prepare for index scan" function */
! 	regproc		amgettuple;		/* "next valid tuple" function, or 0 */
! 	regproc		amgetbitmap;	/* "fetch all valid tuples" function, or 0 */
! 	regproc		amrescan;		/* "(re)start index scan" function */
! 	regproc		amendscan;		/* "end index scan" function */
! 	regproc		ammarkpos;		/* "mark current scan position" function */
! 	regproc		amrestrpos;		/* "restore marked scan position" function */
! 	regproc		ambuild;		/* "build new index" function */
! 	regproc		ambuildempty;	/* "build empty index" function */
! 	regproc		ambulkdelete;	/* bulk-delete function */
! 	regproc		amvacuumcleanup;	/* post-VACUUM cleanup function */
! 	regproc		amcanreturn;	/* can indexscan return IndexTuples? */
! 	regproc		amcostestimate; /* estimate cost of an indexscan */
! 	regproc		amoptions;		/* parse AM-specific parameters */
  } FormData_pg_am;
  
  /* ----------------
--- 34,40 ----
  CATALOG(pg_am,2601)
  {
  	NameData	amname;			/* access method name */
! 	regproc		amhandler;		/* handler function */
  } FormData_pg_am;
  
  /* ----------------
*************** typedef FormData_pg_am *Form_pg_am;
*** 80,138 ****
   *		compiler constants for pg_am
   * ----------------
   */
! #define Natts_pg_am						30
  #define Anum_pg_am_amname				1
! #define Anum_pg_am_amstrategies			2
! #define Anum_pg_am_amsupport			3
! #define Anum_pg_am_amcanorder			4
! #define Anum_pg_am_amcanorderbyop		5
! #define Anum_pg_am_amcanbackward		6
! #define Anum_pg_am_amcanunique			7
! #define Anum_pg_am_amcanmulticol		8
! #define Anum_pg_am_amoptionalkey		9
! #define Anum_pg_am_amsearcharray		10
! #define Anum_pg_am_amsearchnulls		11
! #define Anum_pg_am_amstorage			12
! #define Anum_pg_am_amclusterable		13
! #define Anum_pg_am_ampredlocks			14
! #define Anum_pg_am_amkeytype			15
! #define Anum_pg_am_aminsert				16
! #define Anum_pg_am_ambeginscan			17
! #define Anum_pg_am_amgettuple			18
! #define Anum_pg_am_amgetbitmap			19
! #define Anum_pg_am_amrescan				20
! #define Anum_pg_am_amendscan			21
! #define Anum_pg_am_ammarkpos			22
! #define Anum_pg_am_amrestrpos			23
! #define Anum_pg_am_ambuild				24
! #define Anum_pg_am_ambuildempty			25
! #define Anum_pg_am_ambulkdelete			26
! #define Anum_pg_am_amvacuumcleanup		27
! #define Anum_pg_am_amcanreturn			28
! #define Anum_pg_am_amcostestimate		29
! #define Anum_pg_am_amoptions			30
  
  /* ----------------
   *		initial contents of pg_am
   * ----------------
   */
  
! DATA(insert OID = 403 (  btree		5 2 t f t t t t t t f t t 0 btinsert btbeginscan btgettuple btgetbitmap btrescan btendscan btmarkpos btrestrpos btbuild btbuildempty btbulkdelete btvacuumcleanup btcanreturn btcostestimate btoptions ));
  DESCR("b-tree index access method");
  #define BTREE_AM_OID 403
! DATA(insert OID = 405 (  hash		1 1 f f t f f f f f f f f 23 hashinsert hashbeginscan hashgettuple hashgetbitmap hashrescan hashendscan hashmarkpos hashrestrpos hashbuild hashbuildempty hashbulkdelete hashvacuumcleanup - hashcostestimate hashoptions ));
  DESCR("hash index access method");
  #define HASH_AM_OID 405
! DATA(insert OID = 783 (  gist		0 9 f t f f t t f t t t f 0 gistinsert gistbeginscan gistgettuple gistgetbitmap gistrescan gistendscan gistmarkpos gistrestrpos gistbuild gistbuildempty gistbulkdelete gistvacuumcleanup gistcanreturn gistcostestimate gistoptions ));
  DESCR("GiST index access method");
  #define GIST_AM_OID 783
! DATA(insert OID = 2742 (  gin		0 6 f f f f t t f f t f f 0 gininsert ginbeginscan - gingetbitmap ginrescan ginendscan ginmarkpos ginrestrpos ginbuild ginbuildempty ginbulkdelete ginvacuumcleanup - gincostestimate ginoptions ));
  DESCR("GIN index access method");
  #define GIN_AM_OID 2742
! DATA(insert OID = 4000 (  spgist	0 5 f f f f f t f t f f f 0 spginsert spgbeginscan spggettuple spggetbitmap spgrescan spgendscan spgmarkpos spgrestrpos spgbuild spgbuildempty spgbulkdelete spgvacuumcleanup spgcanreturn spgcostestimate spgoptions ));
  DESCR("SP-GiST index access method");
  #define SPGIST_AM_OID 4000
! DATA(insert OID = 3580 (  brin	   0 15 f f f f t t f t t f f 0 brininsert brinbeginscan - bringetbitmap brinrescan brinendscan brinmarkpos brinrestrpos brinbuild brinbuildempty brinbulkdelete brinvacuumcleanup - brincostestimate brinoptions ));
  DESCR("block range index (BRIN) access method");
  #define BRIN_AM_OID 3580
  
--- 48,78 ----
   *		compiler constants for pg_am
   * ----------------
   */
! #define Natts_pg_am						2
  #define Anum_pg_am_amname				1
! #define Anum_pg_am_amhandler			2
  
  /* ----------------
   *		initial contents of pg_am
   * ----------------
   */
  
! DATA(insert OID = 403 (  btree		bthandler ));
  DESCR("b-tree index access method");
  #define BTREE_AM_OID 403
! DATA(insert OID = 405 (  hash		hashhandler ));
  DESCR("hash index access method");
  #define HASH_AM_OID 405
! DATA(insert OID = 783 (  gist		gisthandler ));
  DESCR("GiST index access method");
  #define GIST_AM_OID 783
! DATA(insert OID = 2742 (  gin		ginhandler ));
  DESCR("GIN index access method");
  #define GIN_AM_OID 2742
! DATA(insert OID = 4000 (  spgist	spghandler ));
  DESCR("SP-GiST index access method");
  #define SPGIST_AM_OID 4000
! DATA(insert OID = 3580 (  brin		brinhandler ));
  DESCR("block range index (BRIN) access method");
  #define BRIN_AM_OID 3580
  
